<?php

class ControllerShippingSpeedy extends Controller {

	private $error = array();

	public function index() {
		$this->load->language('shipping/speedy');

		$this->document->setTitle($this->language->get('heading_title'));

		if (!$this->config->get('speedy_updated_v220')) { //for Abroad Shipping
			$this->updateV220();
		}

		if (!$this->config->get('speedy_updated_v320')) { //for price from file
			$this->updateV320();
		}

		require_once(DIR_SYSTEM . 'library/speedy.php');
		$speedy = new Speedy($this->registry);
		if ($speedy->getError()) {
			$this->error['warning'] = $speedy->getError();
		}

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->request->post['speedy_updated_v220'] = true; //for Abroad Shipping
			$this->request->post['speedy_updated_v320'] = true; //for price from file

			if (isset($this->request->post['speedy_default_weight'])) {
				$this->request->post['speedy_default_weight'] = str_replace(',', '.', $this->request->post['speedy_default_weight']);
			}

			if (!$speedy->isAvailableMoneyTransfer()) {
				$this->request->post['speedy_money_transfer'] = 0;
			}

			$this->model_setting_setting->editSetting('speedy', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			if (version_compare(VERSION, '2.3', '>')) {
				$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true));
			} else {
				$this->response->redirect($this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'));
			}
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_all_zones'] = $this->language->get('text_all_zones');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		$data['text_select_all'] = $this->language->get('text_select_all');
		$data['text_unselect_all'] = $this->language->get('text_unselect_all');
		$data['text_filename'] = $this->language->get('text_filename');
		$data['text_loading'] = $this->language->get('text_loading');
		$data['text_sevice_id'] = $this->language->get('text_sevice_id');

		$data['entry_server_address'] = $this->language->get('entry_server_address');
		$data['entry_username'] = $this->language->get('entry_username');
		$data['entry_password'] = $this->language->get('entry_password');
		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_telephone'] = $this->language->get('entry_telephone');
		$data['entry_workingtime_end'] = $this->language->get('entry_workingtime_end');
		$data['entry_allowed_methods'] = $this->language->get('entry_allowed_methods');
		$data['entry_pricing'] = $this->language->get('entry_pricing');
		$data['entry_fixed_price'] = $this->language->get('entry_fixed_price');
		$data['entry_free_shipping_total'] = $this->language->get('entry_free_shipping_total');
		$data['entry_free_method_city'] = $this->language->get('entry_free_method_city');
		$data['entry_free_method_intercity'] = $this->language->get('entry_free_method_intercity');
		$data['entry_free_method_international'] = $this->language->get('entry_free_method_international');
		$data['entry_back_documents'] = $this->language->get('entry_back_documents');
		$data['entry_back_receipt'] = $this->language->get('entry_back_receipt');
		$data['entry_default_weight'] = $this->language->get('entry_default_weight');
		$data['entry_packing'] = $this->language->get('entry_packing');
		$data['entry_label_printer'] = $this->language->get('entry_label_printer');
		$data['entry_insurance'] = $this->language->get('entry_insurance');
		$data['entry_fragile'] = $this->language->get('entry_fragile');
		$data['entry_from_office'] = $this->language->get('entry_from_office');
		$data['entry_office'] = $this->language->get('entry_office');
		$data['entry_documents'] = $this->language->get('entry_documents');
		$data['entry_fixed_time'] = $this->language->get('entry_fixed_time');
		$data['entry_taking_date'] = $this->language->get('entry_taking_date');
		$data['entry_currency'] = $this->language->get('entry_currency');
		$data['entry_weight_class'] = $this->language->get('entry_weight_class');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_options_before_payment'] = $this->language->get('entry_options_before_payment');
		$data['entry_return_payer_type'] = $this->language->get('entry_return_payer_type');
		$data['entry_return_package_city_service_id'] = $this->language->get('entry_return_package_city_service_id');
		$data['entry_return_package_intercity_service_id'] = $this->language->get('entry_return_package_intercity_service_id');
		$data['entry_return_voucher'] = $this->language->get('entry_return_voucher');
		$data['entry_return_voucher_city_service_id'] = $this->language->get('entry_return_voucher_city_service_id');
		$data['entry_return_voucher_intercity_service_id'] = $this->language->get('entry_return_voucher_intercity_service_id');
		$data['entry_return_voucher_payer_type'] = $this->language->get('entry_return_voucher_payer_type');
		$data['entry_money_transfer'] = $this->language->get('entry_money_transfer');
		$data['entry_courier_sevice'] = $this->language->get('entry_courier_sevice');

		$data['help_fragile'] = $this->language->get('help_fragile');
		$data['help_from_office'] = $this->language->get('help_from_office');
		$data['help_documents'] = $this->language->get('help_documents');
		$data['help_fixed_time'] = $this->language->get('help_fixed_time');
		$data['help_money_transfer'] = $this->language->get('help_money_transfer');
		$data['help_courier_sevice'] = $this->language->get('help_courier_sevice');
		$data['help_filename'] = $this->language->get('help_filename');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_testcredentials'] = $this->language->get('check_credentials_btn_label');
		$data['button_upload'] = $this->language->get('button_upload');

		$data['token'] = $this->session->data['token'];

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['username'])) {
			$data['error_username'] = $this->error['username'];
		} else {
			$data['error_username'] = '';
		}
		
		$data['error_username_credentials'] = 
				$this->language->get('error_username_credentials_chk');
		
		$data['error_password_credentials'] = 
				$this->language->get('error_password_credentials_chk');

		if (isset($this->error['password'])) {
			$data['error_password'] = $this->error['password'];
		} else {
			$data['error_password'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset($this->error['telephone'])) {
			$data['error_telephone'] = $this->error['telephone'];
		} else {
			$data['error_telephone'] = '';
		}

		if (isset($this->error['default_weight'])) {
			$data['error_default_weight'] = $this->error['default_weight'];
		} else {
			$data['error_default_weight'] = '';
		}

		if (isset($this->error['allowed_methods'])) {
			$data['error_allowed_methods'] = $this->error['allowed_methods'];
		} else {
			$data['error_allowed_methods'] = '';
		}

		if (isset($this->error['free_method_international'])) {
			$data['error_free_method_international'] = $this->error['free_method_international'];
		} else {
			$data['error_free_method_international'] = '';
		}

		if (isset($this->error['taking_date'])) {
			$data['error_taking_date'] = $this->error['taking_date'];
		} else {
			$data['error_taking_date'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_shipping'),
			'href' => $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('shipping/speedy', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['action'] = $this->url->link('shipping/speedy', 'token=' . $this->session->data['token'], 'SSL');

		if (version_compare(VERSION, '2.3', '>')) {
			$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true);
		} else {
			$data['cancel'] = $this->url->link('extension/shipping', 'token=' . $this->session->data['token'], 'SSL');
		}

		if (!empty($this->request->post['speedy_server_address'])) {
			$data['speedy_server_address'] = $this->request->post['speedy_server_address'];
		} elseif ($this->config->get('speedy_server_address')) {
			$data['speedy_server_address'] = $this->config->get('speedy_server_address');
		} else {
			$data['speedy_server_address'] = 'https://www.speedy.bg/eps/main01.wsdl';
		}

		if (isset($this->request->post['speedy_username'])) {
			$data['speedy_username'] = $this->request->post['speedy_username'];
		} else {
			$data['speedy_username'] = $this->config->get('speedy_username');
		}

		if (isset($this->request->post['speedy_password'])) {
			$data['speedy_password'] = $this->request->post['speedy_password'];
		} else {
			$data['speedy_password'] = $this->config->get('speedy_password');
		}

		if (isset($this->request->post['speedy_name'])) {
			$data['speedy_name'] = $this->request->post['speedy_name'];
		} else {
			$data['speedy_name'] = $this->config->get('speedy_name');
		}

		if (isset($this->request->post['speedy_telephone'])) {
			$data['speedy_telephone'] = $this->request->post['speedy_telephone'];
		} else {
			$data['speedy_telephone'] = $this->config->get('speedy_telephone');
		}

		if (isset($this->request->post['speedy_workingtime_end_hour'])) {
			$data['speedy_workingtime_end_hour'] = $this->request->post['speedy_workingtime_end_hour'];
		} else {
			$data['speedy_workingtime_end_hour'] = $this->config->get('speedy_workingtime_end_hour');
		}

		if (isset($this->request->post['speedy_workingtime_end_min'])) {
			$data['speedy_workingtime_end_min'] = $this->request->post['speedy_workingtime_end_min'];
		} else {
			$data['speedy_workingtime_end_min'] = $this->config->get('speedy_workingtime_end_min');
		}

		if (isset($this->request->post['speedy_allowed_methods'])) {
			$data['speedy_allowed_methods'] = $this->request->post['speedy_allowed_methods'];
		} elseif ($this->config->get('speedy_allowed_methods') && $this->request->server['REQUEST_METHOD'] != 'POST') {
			$data['speedy_allowed_methods'] = $this->config->get('speedy_allowed_methods');
		} else {
			$data['speedy_allowed_methods'] = array();
		}

		if (isset($this->request->post['speedy_pricing'])) {
			$data['speedy_pricing'] = $this->request->post['speedy_pricing'];
		} else {
			$data['speedy_pricing'] = $this->config->get('speedy_pricing');
		}

		if (isset($this->request->post['speedy_option_before_payment'])) {
			$data['speedy_option_before_payment'] = $this->request->post['speedy_option_before_payment'];
		} else {
			$data['speedy_option_before_payment'] = $this->config->get('speedy_option_before_payment');
		}

		if (isset($this->request->post['speedy_return_payer_type'])) {
			$data['speedy_return_payer_type'] = $this->request->post['speedy_return_payer_type'];
		} else {
			$data['speedy_return_payer_type'] = $this->config->get('speedy_return_payer_type');
		}

		if (isset($this->request->post['speedy_return_package_city_service_id'])) {
			$data['speedy_return_package_city_service_id'] = $this->request->post['speedy_return_package_city_service_id'];
		} else {
			$data['speedy_return_package_city_service_id'] = $this->config->get('speedy_return_package_city_service_id');
		}

		if (isset($this->request->post['speedy_return_package_intercity_service_id'])) {
			$data['speedy_return_package_intercity_service_id'] = $this->request->post['speedy_return_package_intercity_service_id'];
		} else {
			$data['speedy_return_package_intercity_service_id'] = $this->config->get('speedy_return_package_intercity_service_id');
		}

		if (isset($this->request->post['speedy_return_voucher'])) {
			$data['speedy_return_voucher'] = $this->request->post['speedy_return_voucher'];
		} else {
			$data['speedy_return_voucher'] = $this->config->get('speedy_return_voucher');
		}

		if (isset($this->request->post['speedy_return_voucher_city_service_id'])) {
			$data['speedy_return_voucher_city_service_id'] = $this->request->post['speedy_return_voucher_city_service_id'];
		} else {
			$data['speedy_return_voucher_city_service_id'] = $this->config->get('speedy_return_voucher_city_service_id');
		}

		if (isset($this->request->post['speedy_return_voucher_intercity_service_id'])) {
			$data['speedy_return_voucher_intercity_service_id'] = $this->request->post['speedy_return_voucher_intercity_service_id'];
		} else {
			$data['speedy_return_voucher_intercity_service_id'] = $this->config->get('speedy_return_voucher_intercity_service_id');
		}

		if (isset($this->request->post['speedy_return_voucher_payer_type'])) {
			$data['speedy_return_voucher_payer_type'] = $this->request->post['speedy_return_voucher_payer_type'];
		} else {
			$data['speedy_return_voucher_payer_type'] = $this->config->get('speedy_return_voucher_payer_type');
		}

		if (isset($this->request->post['speedy_fixed_price'])) {
			$data['speedy_fixed_price'] = $this->request->post['speedy_fixed_price'];
		} else {
			$data['speedy_fixed_price'] = $this->config->get('speedy_fixed_price');
		}

		if (isset($this->request->post['speedy_free_shipping_total'])) {
			$data['speedy_free_shipping_total'] = $this->request->post['speedy_free_shipping_total'];
		} else {
			$data['speedy_free_shipping_total'] = $this->config->get('speedy_free_shipping_total');
		}

		if (isset($this->request->post['speedy_free_method_city'])) {
			$data['speedy_free_method_city'] = $this->request->post['speedy_free_method_city'];
		} else {
			$data['speedy_free_method_city'] = $this->config->get('speedy_free_method_city');
		}

		if (isset($this->request->post['speedy_free_method_intercity'])) {
			$data['speedy_free_method_intercity'] = $this->request->post['speedy_free_method_intercity'];
		} else {
			$data['speedy_free_method_intercity'] = $this->config->get('speedy_free_method_intercity');
		}

		if (isset($this->request->post['speedy_free_method_international'])) {
			$data['speedy_free_method_international'] = $this->request->post['speedy_free_method_international'];
		} elseif ($this->config->get('speedy_free_method_international') && $this->request->server['REQUEST_METHOD'] != 'POST') {
			$data['speedy_free_method_international'] = $this->config->get('speedy_free_method_international');
		} else {
			$data['speedy_free_method_international'] = array();
		}

		if (isset($this->request->post['speedy_back_documents'])) {
			$data['speedy_back_documents'] = $this->request->post['speedy_back_documents'];
		} else {
			$data['speedy_back_documents'] = $this->config->get('speedy_back_documents');
		}

		if (isset($this->request->post['speedy_back_receipt'])) {
			$data['speedy_back_receipt'] = $this->request->post['speedy_back_receipt'];
		} else {
			$data['speedy_back_receipt'] = $this->config->get('speedy_back_receipt');
		}

		if (isset($this->request->post['speedy_default_weight'])) {
			$data['speedy_default_weight'] = $this->request->post['speedy_default_weight'];
		} else {
			$data['speedy_default_weight'] = $this->config->get('speedy_default_weight');
		}

		if (isset($this->request->post['speedy_packing'])) {
			$data['speedy_packing'] = $this->request->post['speedy_packing'];
		} else {
			$data['speedy_packing'] = $this->config->get('speedy_packing');
		}

		if (isset($this->request->post['speedy_label_printer'])) {
			$data['speedy_label_printer'] = $this->request->post['speedy_label_printer'];
		} else {
			$data['speedy_label_printer'] = $this->config->get('speedy_label_printer');
		}

		if (isset($this->request->post['speedy_insurance'])) {
			$data['speedy_insurance'] = $this->request->post['speedy_insurance'];
		} else {
			$data['speedy_insurance'] = $this->config->get('speedy_insurance');
		}

		if (isset($this->request->post['speedy_fragile'])) {
			$data['speedy_fragile'] = $this->request->post['speedy_fragile'];
		} else {
			$data['speedy_fragile'] = $this->config->get('speedy_fragile');
		}

		if (isset($this->request->post['speedy_from_office'])) {
			$data['speedy_from_office'] = $this->request->post['speedy_from_office'];
		} else {
			$data['speedy_from_office'] = $this->config->get('speedy_from_office');
		}

		if (isset($this->request->post['speedy_office_id'])) {
			$data['speedy_office_id'] = $this->request->post['speedy_office_id'];
		} else {
			$data['speedy_office_id'] = $this->config->get('speedy_office_id');
		}

		if (isset($this->request->post['speedy_documents'])) {
			$data['speedy_documents'] = $this->request->post['speedy_documents'];
		} else {
			$data['speedy_documents'] = $this->config->get('speedy_documents');
		}

		if (isset($this->request->post['speedy_fixed_time'])) {
			$data['speedy_fixed_time'] = $this->request->post['speedy_fixed_time'];
		} else {
			$data['speedy_fixed_time'] = $this->config->get('speedy_fixed_time');
		}

		if (isset($this->request->post['speedy_taking_date'])) {
			$data['speedy_taking_date'] = $this->request->post['speedy_taking_date'];
		} else {
			$data['speedy_taking_date'] = $this->config->get('speedy_taking_date');
		}

		if (isset($this->request->post['speedy_currency'])) {
			$data['speedy_currency'] = $this->request->post['speedy_currency'];
		} else {
			$data['speedy_currency'] = $this->config->get('speedy_currency');
		}

		if (isset($this->request->post['speedy_weight_class_id'])) {
			$data['speedy_weight_class_id'] = $this->request->post['speedy_weight_class_id'];
		} else {
			$data['speedy_weight_class_id'] = $this->config->get('speedy_weight_class_id');
		}

		if (isset($this->request->post['speedy_order_status_id'])) {
			$data['speedy_order_status_id'] = $this->request->post['speedy_order_status_id'];
		} else {
			$data['speedy_order_status_id'] = $this->config->get('speedy_order_status_id');
		}

		if (isset($this->request->post['speedy_geo_zone_id'])) {
			$data['speedy_geo_zone_id'] = $this->request->post['speedy_geo_zone_id'];
		} else {
			$data['speedy_geo_zone_id'] = $this->config->get('speedy_geo_zone_id');
		}

		if (isset($this->request->post['speedy_status'])) {
			$data['speedy_status'] = $this->request->post['speedy_status'];
		} else {
			$data['speedy_status'] = $this->config->get('speedy_status');
		}

		if (isset($this->request->post['speedy_sort_order'])) {
			$data['speedy_sort_order'] = $this->request->post['speedy_sort_order'];
		} else {
			$data['speedy_sort_order'] = $this->config->get('speedy_sort_order');
		}

		if (isset($this->request->post['speedy_invoice_courier_sevice_as_text'])) {
			$data['speedy_invoice_courier_sevice_as_text'] = $this->request->post['speedy_invoice_courier_sevice_as_text'];
		} else {
			$data['speedy_invoice_courier_sevice_as_text'] = $this->config->get('speedy_invoice_courier_sevice_as_text');
		}

		$this->load->model('localisation/currency');

		$data['currencies'] = $this->model_localisation_currency->getCurrencies();

		$this->load->model('localisation/weight_class');

		$data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$this->load->model('localisation/geo_zone');

		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

		$data['services'] = $speedy->getServices($this->language->get('code'));

		$data['offices'] = $speedy->getOffices(null, null, $this->language->get('code'));

		if ($speedy->isAvailableMoneyTransfer()) {
			$data['available_money_transfer'] = true;

			if (isset($this->request->post['speedy_money_transfer'])) {
				$data['speedy_money_transfer'] = $this->request->post['speedy_money_transfer'];
			} else {
				$data['speedy_money_transfer'] = $this->config->get('speedy_money_transfer');
			}
		} else {
			$data['available_money_transfer'] = false;
			$data['speedy_money_transfer'] = false;
		}

		$data['pricings'] = array(
			'calculator' => $this->language->get('text_calculator'),
			'calculator_fixed' => $this->language->get('text_calculator_fixed'),
			'fixed' => $this->language->get('text_fixed_price'),
			'free' => $this->language->get('text_free_shipping'),
			'table_rate' => $this->language->get('text_table_rate'),
		);

		$data['options_before_payment'] = array(
			'no_option' => $this->language->get('text_no'),
			'test'      => $this->language->get('text_test_before_payment'),
			'open'      => $this->language->get('text_open_before_payment'),
		);

		$data['return_payer_types'] = array(
			0      => $this->language->get('text_sender'),
			1      => $this->language->get('text_receiver'),
		);

		$data['payer_types'] = array(
			ParamCalculation::PAYER_TYPE_SENDER   => $this->language->get('text_sender'),
			ParamCalculation::PAYER_TYPE_RECEIVER => $this->language->get('text_receiver'),
		);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('shipping/speedy.tpl', $data));
	}

	public function checkcredentials() {
		
		$this->load->language('shipping/speedy');

		//$this->document->setTitle($this->language->get('heading_title'));

		require_once(DIR_SYSTEM . 'library/speedy.php');
		$speedy = new Speedy($this->registry);

		if (!$this->request->post['username'] || !$this->request->post['username']) {
			$this->response->setOutput(json_encode(array('error' => 1, 'message' => $this->language->get('incorrect_user_and_pass'))));

			return;
		}

		$username = $this->request->post['username'];
		$password = $this->request->post['password'];

		$isCredentialsCorrect = $speedy->checkCredentials($username, $password);

		if ($isCredentialsCorrect) {
			$this->response->setOutput(json_encode(array('ok' => 1, 'message' => $this->language->get('correct_user_and_pass'))));
		} else {
			$this->response->setOutput(json_encode(array('error' => 1, 'message' => $this->language->get('incorrect_user_and_pass'))));
		}
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'shipping/speedy')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['speedy_server_address']) {
			$this->request->post['speedy_server_address'] = 'https://www.speedy.bg/eps/main01.wsdl';
		}

		if (!$this->request->post['speedy_username']) {
			$this->error['username'] = $this->language->get('error_username');
		}

		if (!$this->request->post['speedy_password']) {
			$this->error['password'] = $this->language->get('error_password');
		}

		if (!$this->request->post['speedy_name']) {
			$this->error['name'] = $this->language->get('error_name');
		}

		if (!$this->request->post['speedy_telephone']) {
			$this->error['telephone'] = $this->language->get('error_telephone');
		}

		if (!$this->request->post['speedy_default_weight']) {
			$this->error['default_weight'] = $this->language->get('error_default_weight');
		} elseif ($this->request->post['speedy_default_weight'] && !is_numeric($this->request->post['speedy_default_weight'])) {
			$this->error['default_weight'] = $this->language->get('error_invalid_number');
		}

		if (!isset($this->request->post['speedy_allowed_methods'])) {
			$this->error['allowed_methods'] = $this->language->get('error_allowed_methods');
		}

		if ($this->request->post['speedy_pricing'] == 'free' && !isset($this->request->post['speedy_free_method_international'])) {
			$this->error['free_method_international'] = $this->language->get('error_free_method_international');
		}

		if ($this->request->post['speedy_taking_date'] && !is_numeric($this->request->post['speedy_taking_date'])) {
			$this->error['taking_date'] = $this->language->get('error_invalid_number');
		}

		return !$this->error;
	}

	public function install() {
		$this->load->model('setting/setting');

		$shipping_data = array(
			'shipping_estimator' => 0,
			'shipping_status' => 1,
			'shipping_sort_order' => $this->config->get('shipping_sort_order')
		);

		$this->model_setting_setting->editSetting('shipping', $shipping_data);

		$cod_data = array(
			'cod_status' => 0
		);

		$this->model_setting_setting->editSetting('cod', $cod_data);

		$this->load->model('shipping/speedy');

		$this->model_shipping_speedy->createTables();

		@mail('support@extensadev.com', 'Speedy Shipping Module installed', HTTP_CATALOG . ' - ' . $this->config->get('config_name') . "\r\n" . 'version - ' . VERSION . "\r\n" . 'IP - ' . $this->request->server['REMOTE_ADDR'], 'MIME-Version: 1.0' . "\r\n" . 'Content-type: text/plain; charset=UTF-8' . "\r\n" . 'From: ' . $this->config->get('config_owner') . ' <' . $this->config->get('config_email') . '>' . "\r\n");
	}

	public function uninstall() {
		$this->load->model('shipping/speedy');

		$this->model_shipping_speedy->deleteTables();
	}

	private function updateV220() { //for Abroad Shipping
		$this->load->model('shipping/speedy');

		$this->model_shipping_speedy->updateTablesV220();

		$this->load->model('setting/setting');

		$data = $this->model_setting_setting->getSetting('speedy');
		$data['speedy_updated_v220'] = true;

		$this->model_setting_setting->editSetting('speedy', $data);
	}

	private function updateV320() { // price from file
		$this->load->model('shipping/speedy');

		$this->model_shipping_speedy->updateTablesV320();

		$this->load->model('setting/setting');

		$data = $this->model_setting_setting->getSetting('speedy');
		$data['speedy_updated_v320'] = true;

		$this->model_setting_setting->editSetting('speedy', $data);
	}

	public function upload() {
		$this->load->language('shipping/speedy');
		$this->load->model('shipping/speedy');

		$json = array();

		// Check user has permission
		if (!$this->user->hasPermission('modify', 'shipping/speedy')) {
			$json['error'] = $this->language->get('error_permission');
		}


		if (!$json) {
			if (!empty($this->request->files['file']['name']) && is_file($this->request->files['file']['tmp_name'])) {
				// Sanitize the filename
				$filename = basename(html_entity_decode($this->request->files['file']['name'], ENT_QUOTES, 'UTF-8'));

				// Validate the filename length
				if ((utf8_strlen($filename) < 3) || (utf8_strlen($filename) > 128)) {
					$json['error'] = $this->language->get('error_filename');
				}

				// Allowed file extension types
				$allowed = array();

				$extension_allowed = preg_replace('~\r?\n~', "\n", 'csv');

				$filetypes = explode("\n", $extension_allowed);

				foreach ($filetypes as $filetype) {
					$allowed[] = trim($filetype);
				}

				if (!in_array(strtolower(substr(strrchr($filename, '.'), 1)), $allowed)) {
					$json['error'] = $this->language->get('error_filetype');
				}

				// Return any upload error
				if ($this->request->files['file']['error'] != UPLOAD_ERR_OK) {
					$json['error'] = $this->language->get('error_upload_' . $this->request->files['file']['error']);
				}
			} else {
				$json['error'] = $this->language->get('error_upload');
			}
		}

		if (!$json) {
			$data = array();

			if (($handle_import = fopen($this->request->files['file']['tmp_name'], 'r')) !== false) {
				$handle_import_data = fgetcsv($handle_import, 100000); // remove title line

				$file_columns = array(
					'ServiceID',
					'TakeFromOffice',
					'Weight',
					'OrderTotal',
					'PriceWithoutVAT',
					'FixedTimeDelivery',
				);

				$file_columns_indexes = array();
				foreach($handle_import_data as $index => $columnName) {
					$file_columns_indexes[$columnName] = array_search($columnName, $handle_import_data);
				}

				sort($handle_import_data);
				sort($file_columns);

				if ($handle_import_data != $file_columns) {
					$json['error'] = $this->language->get('error_file_columns');
				}

				if (!$json) {
					while (($handle_import_data = fgetcsv($handle_import, 100000)) !== false) {
						$data[] = array(
							'service_id' => $handle_import_data[$file_columns_indexes['ServiceID']],
							'take_from_office' => $handle_import_data[$file_columns_indexes['TakeFromOffice']],
							'weight' => str_replace(',', '.', $handle_import_data[$file_columns_indexes['Weight']]),
							'order_total' => str_replace(',', '.', $handle_import_data[$file_columns_indexes['OrderTotal']]),
							'price_without_vat' => str_replace(',', '.', $handle_import_data[$file_columns_indexes['PriceWithoutVAT']]),
							'fixed_time_delivery' => str_replace(',', '.', $handle_import_data[$file_columns_indexes['FixedTimeDelivery']]),
						);
					}

					$this->model_shipping_speedy->importFilePrice($data);

					$json['fileprice_name'] = $filename;

					$json['success'] = $this->language->get('text_upload');
				}
			}
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}

?>